package com.ruoyi.frequency.collect.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.controller.req.CollectObjectReq;
import com.ruoyi.controller.req.CollectPageReq;
import com.ruoyi.controller.resp.WorksPageResp;
import com.ruoyi.frequency.collect.entity.Collect;
import com.ruoyi.frequency.news.entity.News;
import com.ruoyi.post.controller.resp.PostPageResp;
import com.ruoyi.response.ResponseData;
import com.ruoyi.vo.UserVo;

import java.util.List;

/**
 * 收藏Service接口
 * 
 * @author zj
 * @date 2023-10-16
 */
public interface CollectService extends IService<Collect>
{
    /**
     * 查询收藏
     * 
     * @param id 收藏主键
     * @return 收藏
     */
    public Collect selectCollectById(Long id);

    /**
     * 查询收藏列表
     * 
     * @param collect 收藏
     * @return 收藏集合
     */
    public List<Collect> selectCollectList(Collect collect);

    /**
     * 新增收藏
     * 
     * @param collect 收藏
     * @return 结果
     */
    public int insertCollect(Collect collect);

    /**
     * 修改收藏
     * 
     * @param collect 收藏
     * @return 结果
     */
    public int updateCollect(Collect collect);

    /**
     * 批量删除收藏
     * 
     * @param ids 需要删除的收藏主键集合
     * @return 结果
     */
    public int deleteCollectByIds(Long[] ids);

    /**
     * 删除收藏信息
     * 
     * @param id 收藏主键
     * @return 结果
     */
    public int deleteCollectById(Long id);


    /**
     * 收藏
     * @param req
     * @param userVo
     * @return
     */
    ResponseData collectObject(CollectObjectReq req, UserVo userVo);


    /**
     * 收藏列表
     * @param req
     * @param userVo
     * @return
     */
    ResponseData collectPage(CollectPageReq req, UserVo userVo);

    Page<WorksPageResp> getCollectWorksPage(CollectPageReq req, UserVo userVo);

    Page<News> getCollectNewsPage(CollectPageReq req, UserVo userVo);

    Page<PostPageResp> getCollectPostPage(CollectPageReq req, UserVo userVo);

    /**
     * 收藏列表(别人查看)
     * @param req
     * @return
     */
    ResponseData otherCollectPage(CollectPageReq req, UserVo userVo);

    Integer getUserCollectNum(UserVo userVo,Integer type);
}
